/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FacebookAdsControllerActionCampaignRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FacebookAdsControllerActionCampaignRequest{}

// FacebookAdsControllerActionCampaignRequest struct for FacebookAdsControllerActionCampaignRequest
type FacebookAdsControllerActionCampaignRequest struct {
	OAuthId   *string `json:"oAuthId,omitempty"`
	AccountId *string `json:"accountId,omitempty"`
}

// NewFacebookAdsControllerActionCampaignRequest instantiates a new FacebookAdsControllerActionCampaignRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFacebookAdsControllerActionCampaignRequest() *FacebookAdsControllerActionCampaignRequest {
	this := FacebookAdsControllerActionCampaignRequest{}
	return &this
}

// NewFacebookAdsControllerActionCampaignRequestWithDefaults instantiates a new FacebookAdsControllerActionCampaignRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFacebookAdsControllerActionCampaignRequestWithDefaults() *FacebookAdsControllerActionCampaignRequest {
	this := FacebookAdsControllerActionCampaignRequest{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *FacebookAdsControllerActionCampaignRequest) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookAdsControllerActionCampaignRequest) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *FacebookAdsControllerActionCampaignRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *FacebookAdsControllerActionCampaignRequest) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetAccountId returns the AccountId field value if set, zero value otherwise.
func (o *FacebookAdsControllerActionCampaignRequest) GetAccountId() string {
	if o == nil || IsNil(o.AccountId) {
		var ret string
		return ret
	}
	return *o.AccountId
}

// GetAccountIdOk returns a tuple with the AccountId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookAdsControllerActionCampaignRequest) GetAccountIdOk() (*string, bool) {
	if o == nil || IsNil(o.AccountId) {
		return nil, false
	}
	return o.AccountId, true
}

// HasAccountId returns a boolean if a field has been set.
func (o *FacebookAdsControllerActionCampaignRequest) HasAccountId() bool {
	if o != nil && !IsNil(o.AccountId) {
		return true
	}

	return false
}

// SetAccountId gets a reference to the given string and assigns it to the AccountId field.
func (o *FacebookAdsControllerActionCampaignRequest) SetAccountId(v string) {
	o.AccountId = &v
}

func (o FacebookAdsControllerActionCampaignRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FacebookAdsControllerActionCampaignRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.AccountId) {
		toSerialize["accountId"] = o.AccountId
	}
	return toSerialize, nil
}

type NullableFacebookAdsControllerActionCampaignRequest struct {
	value *FacebookAdsControllerActionCampaignRequest
	isSet bool
}

func (v NullableFacebookAdsControllerActionCampaignRequest) Get() *FacebookAdsControllerActionCampaignRequest {
	return v.value
}

func (v *NullableFacebookAdsControllerActionCampaignRequest) Set(val *FacebookAdsControllerActionCampaignRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableFacebookAdsControllerActionCampaignRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableFacebookAdsControllerActionCampaignRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFacebookAdsControllerActionCampaignRequest(val *FacebookAdsControllerActionCampaignRequest) *NullableFacebookAdsControllerActionCampaignRequest {
	return &NullableFacebookAdsControllerActionCampaignRequest{value: val, isSet: true}
}

func (v NullableFacebookAdsControllerActionCampaignRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFacebookAdsControllerActionCampaignRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
